#
# UC: 21180 - Computação Numérica
# e-fólio A 2024-25
#
# Aluno: 2203524 - Carlos Miguel Faria Martins da Costa
#

function [r,e,n,x] = alg_newton(f,df,x0,emax,kmax)
  # Contador de iterações
  n = 0;

  # Lista de estimativas
  x = [x0];

  # Estimativa inicial
  r = x0;

  # Repete enquanto o número de iterações for menor que o máximo
  while n < kmax
    # Incrementa contador de iterações
    n = n + 1;

    # Obtem x antigo
    x_ = x(end);

    # Calcula diferença
    d = f(x_) / df(x_);

    # Calcula estimativa
    r = x_ - d;

    # Adiciona na lista:
    x = [x, r];

    # Calcula estimativa de erro absoluto
    e = abs(d);

    # Critério de parada:
    if e < emax
      break
    endif

  endwhile

end
