#
# UC: 21180 - Computação Numérica
# e-fólio A 2024-25
#
# Aluno: 2203524 - Carlos Miguel Faria Martins da Costa
#

# Define as estimativas iniciais
estimativas_iniciais = [1.0, 10.0];

# Para cada estimativa inicial
for i = 1:2
  # Execução para x0 = 1
  x0 = estimativas_iniciais(i);

  # Aplica método de newton
  [r,e,n,x] = alg_newton(@fx, @dfx, x0, 1e-9, 500);

  # Imprime mensagens
  printf("Estimativa inicial: x0 = %.16f\n", x(1));
  printf("Estimativa da raiz: r = %.16f\n", r);
  printf("Estimativa de erro: e = %.16f\n", e);
  printf("Intervalo onde se encontra a raiz: I = (%.16f, %.16f)\n", r-e,r+e);

  # Calcula e imprime o valor teórico de C
  c = abs(d2fx(r)/dfx(r))/2;

  printf("Constante de convergência: C = %.16f\n", c);

  # Imprime tabela com iteração, estimativa e constante de convergência para cada
  # iteração.

  # Cabeçalho
  printf("\nIteração k\t\tx_k\t\t\tc_k\n");

  for k = 1:(n-1)
    # Obtem a k-ésima e (k+1)-ésima estimativas:
    xk = x(k);
    xk1 = x(k+1);

    # Calcula C_k
    ck = abs(r - xk1)/(r - xk)^2;



    # Exibe linha da tabela
    printf("%d\t\t%.16f\t%.16f\n", (k-1), xk, ck);

  end

  # Quebra de linha
  printf("\n");
end




